OpenMM

- Main Page
- Related Pages
- Classes

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
Classes | Public Member Functions | Protected Member Functions | List of all members
CMAPTorsionForce Class Reference

This class implements an interaction between pairs of dihedral angles. More...

`#include <CMAPTorsionForce.h>`

Inheritance diagram for CMAPTorsionForce:

## Public Member Functions
| CMAPTorsionForce ()
| Create a CMAPTorsionForce. More...
int | getNumMaps () const
| Get the number of maps that have been defined. More...
int | getNumTorsions () const
| Get the number of CMAP torsion terms in the potential function. More...
int | addMap (int size, const std::vector< double > &energy)
| Create a new map that can be used for torsion pairs. More...
void | getMapParameters (int index, int &size, std::vector< double > &energy) const
| Get the energy values of a map. More...
void | setMapParameters (int index, int size, const std::vector< double > &energy)
| Set the energy values of a map. More...
int | addTorsion (int map, int a1, int a2, int a3, int a4, int b1, int b2, int b3, int b4)
| Add a CMAP torsion term to the force field. More...
void | getTorsionParameters (int index, int &map, int &a1, int &a2, int &a3, int &a4, int &b1, int &b2, int &b3, int &b4) const
| Get the force field parameters for a CMAP torsion term. More...
void | setTorsionParameters (int index, int map, int a1, int a2, int a3, int a4, int b1, int b2, int b3, int b4)
| Set the force field parameters for a CMAP torsion term. More...
void | updateParametersInContext (Context &context)
| Update the map and torsion parameters in a Context to match those stored in this Force object. More...
bool | usesPeriodicBoundaryConditions () const
| Returns whether or not this force makes use of periodic boundary conditions. More...
Public Member Functions inherited from Force
| Force ()
virtual | ~Force ()
int | getForceGroup () const
| Get the force group this Force belongs to. More...
void | setForceGroup (int group)
| Set the force group this Force belongs to. More...

## Protected Member Functions
ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System. More...
Protected Member Functions inherited from Force
ForceImpl & | getImplInContext (Context &context)
| Get the ForceImpl corresponding to this Force in a Context. More...
ContextImpl & | getContextImpl (Context &context)
| Get the ContextImpl corresponding to a Context. More...

## Detailed Description

This class implements an interaction between pairs of dihedral angles.

The interaction energy is defined by an "energy correction map" (CMAP), which is simply a set of tabulated energy values on a regular grid of (phi, psi) angles. Natural cubic spline interpolation is used to compute forces and energies at arbitrary values of the two angles.

To use this class, first create one or more energy correction maps by calling addMap(). For each one, you provide an array of energies at uniformly spaced values of the two angles. Next, add interactions by calling addTorsion(). For each one, you specify the sequence of particles used to calculate each of the two dihedral angles, and the index of the map used to calculate their interaction energy.

## Constructor & Destructor Documentation

CMAPTorsionForce | ( |  | ) |

Create a CMAPTorsionForce.

## Member Function Documentation

int addMap | ( | int | size,
|  | const std::vector< double > & | energy
| ) |  |

Create a new map that can be used for torsion pairs.

Parameters

  size | the size of the map along each dimension
  energy | the energy values for the map. This must be of length size*size. The element energy[i+size*j] contains the energy when the first torsion angle equals i*2*PI/size and the second torsion angle equals j*2*PI/size.

Returns
  the index of the map that was added

int addTorsion | ( | int | map,
|  | int | a1,
|  | int | a2,
|  | int | a3,
|  | int | a4,
|  | int | b1,
|  | int | b2,
|  | int | b3,
|  | int | b4
| ) |  |

Add a CMAP torsion term to the force field.

Parameters

  map | the index of the map to use for this term
  a1 | the index of the first particle forming the first torsion
  a2 | the index of the second particle forming the first torsion
  a3 | the index of the third particle forming the first torsion
  a4 | the index of the fourth particle forming the first torsion
  b1 | the index of the first particle forming the second torsion
  b2 | the index of the second particle forming the second torsion
  b3 | the index of the third particle forming the second torsion
  b4 | the index of the fourth particle forming the second torsion

Returns
  the index of the torsion that was added

ForceImpl* createImpl | ( |  | ) | const
| protected virtual

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

void getMapParameters | ( | int | index,
|  | int & | size,
|  | std::vector< double > & | energy
| ) |  | const

Get the energy values of a map.

Parameters

  index | the index of the map for which to get energy values
  size | the size of the map along each dimension
  energy | the energy values for the map. This must be of length size*size. The element energy[i+size*j] contains the energy when the first torsion angle equals i*2*PI/size and the second torsion angle equals j*2*PI/size.

int getNumMaps | ( |  | ) | const
| inline

Get the number of maps that have been defined.

int getNumTorsions | ( |  | ) | const
| inline

Get the number of CMAP torsion terms in the potential function.

void getTorsionParameters | ( | int | index,
|  | int & | map,
|  | int & | a1,
|  | int & | a2,
|  | int & | a3,
|  | int & | a4,
|  | int & | b1,
|  | int & | b2,
|  | int & | b3,
|  | int & | b4
| ) |  | const

Get the force field parameters for a CMAP torsion term.

Parameters

  index | the index of the torsion for which to get parameters
  map | the index of the map to use for this term
  a1 | the index of the first particle forming the first torsion
  a2 | the index of the second particle forming the first torsion
  a3 | the index of the third particle forming the first torsion
  a4 | the index of the fourth particle forming the first torsion
  b1 | the index of the first particle forming the second torsion
  b2 | the index of the second particle forming the second torsion
  b3 | the index of the third particle forming the second torsion
  b4 | the index of the fourth particle forming the second torsion

void setMapParameters | ( | int | index,
|  | int | size,
|  | const std::vector< double > & | energy
| ) |  |

Set the energy values of a map.

Parameters

  index | the index of the map for which to set energy values
  size | the size of the map along each dimension
  energy | the energy values for the map. This must be of length size*size. The element energy[i+size*j] contains the energy when the first torsion angle equals i*2*PI/size and the second torsion angle equals j*2*PI/size.

void setTorsionParameters | ( | int | index,
|  | int | map,
|  | int | a1,
|  | int | a2,
|  | int | a3,
|  | int | a4,
|  | int | b1,
|  | int | b2,
|  | int | b3,
|  | int | b4
| ) |  |

Set the force field parameters for a CMAP torsion term.

Parameters

  index | the index of the torsion for which to set parameters
  map | the index of the map to use for this term
  a1 | the index of the first particle forming the first torsion
  a2 | the index of the second particle forming the first torsion
  a3 | the index of the third particle forming the first torsion
  a4 | the index of the fourth particle forming the first torsion
  b1 | the index of the first particle forming the second torsion
  b2 | the index of the second particle forming the second torsion
  b3 | the index of the third particle forming the second torsion
  b4 | the index of the fourth particle forming the second torsion

void updateParametersInContext | ( | Context & | context | ) |

Update the map and torsion parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setMapParameters() and setTorsionParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

The only information that can be updated with this method is the energy values for a map, and the map index for a torsion. The size of a map and the set of particles involved in a torsion cannot be changed. Also, new bonds and torsions cannot be added.

bool usesPeriodicBoundaryConditions | ( |  | ) | const
| inline virtual

Returns whether or not this force makes use of periodic boundary conditions.

Returns
  false

Reimplemented from Force.

The documentation for this class was generated from the following file:

- CMAPTorsionForce.h